--[[	This gets the action id for a skill then triggers an alert
	whenever that skill is available.

	Can be change to look for a different skill by modifying the ABILITY_NAME variable

	by Barghast 
]]


-- Configuration variables
ABILITY_NAME  = "Overpower";

ABILITY_sound = "sound/interface/igPlayerBind.wav"

AbilityPrevState =  1;
AbilityActionId	 = -1;
AbilityMod_PlayerClass = nil;
AbilityMod_Config_Loaded = 0;
ActionButton_OnUpdate_orig = nil;


function AbilityMod_OnLoad()

	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("VARIABLES_LOADED");

end



function AbilityMod_OnEvent()


	if (event == "UNIT_NAME_UPDATE" and arg1 == "player") then
		local playerName = UnitName("player");
		if (playerName ~= UKNOWNBEING and playerName ~= UNKNOWNOBJECT) then
			AbilityMod_PlayerClass = UnitClass("player");
		end

		if (AbilityMod_PlayerClass and AbilityMod_Config_Loaded) then
			AbilityMod_Config();
		end
	elseif (event == "VARIABLES_LOADED") then
		AbilityMod_Config_Loaded = 1;
		if (AbilityMod_PlayerClass~= nil) then
			AbilityMod_Config();
		end
	end
end



function AbilityMod_Config()


DEFAULT_CHAT_FRAME:AddMessage("Config");

        this:UnregisterEvent("UNIT_NAME_UPDATE");
	this:UnregisterEvent("VARIABLES_LOADED");

	---  go find out the button number
	AbilityActionId = Ability_GetActionId();

	--- Can't find the ability 
	if AbilityActionId == -1 then
		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage("Ability Mod Disabled");
		end
		return;
	end	


        --- Hook into existing function
       	ActionButton_UpdateUsable_Orig  = ActionButton_UpdateUsable;
	ActionButton_UpdateUsable       = AbilityMod_UpdateEvent;	

	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("Ability Mod loaded");
	end
	UIErrorsFrame:AddMessage("Ability Mod loaded", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);

end



function AbilityMod_UpdateEvent()

	--- Perform original function we are just piggybacking afterwards
	ActionButton_UpdateUsable_Orig()

--        local abilitybutton  = ActionButton_GetPagedID(this)
--	IF ( abilitybutton ~= AbilityActionId ) then

	if ( ActionButton_GetPagedID(this) ~= AbilityActionId ) then
	 	return;
	end
          
	--- Note to self check if these variables already loaded at this point maybe can cut corner here
	local isUsable, notEnoughMana = IsUsableAction(AbilityActionId);
	if (isUsable) then
		local start, duration, enable = GetActionCooldown(AbilityActionId);
		if ( start > 0 and duration > 0 and enable > 0) then
			AbilityPrevState =  1;
		else
			if (AbilityPrevState == 1) then
				--- NOW ACTIVE 
				PlaySoundFile(ABILITY_sound) 
				UIErrorsFrame:AddMessage(ABILITY_NAME, 1.0, 1.0, 1.0, 1.0, 2);
				AbilityPrevState =  2;
			end
		end
	else
		AbilityPrevState =  1;
	end

end


---- Check for the skill 
function Ability_GetActionId()
	for i = 1, 120 do
		if (HasAction(i)) then 
			local ttext = nil;
			local textLeft = nil;
	
			AbilityModtooltip:SetAction(i)	;
			ttext = getglobal("AbilityModtooltipTextLeft1");
			if(ttext and ttext:IsVisible() and ttext:GetText() ~= nil)	then
				textLeft = ttext:GetText();
				if ( ( textLeft ) and ( ( ABILITY_NAME == textLeft ) ) ) then
					return i;
				end
			end

		end
	end
	return -1;
end


